# ingress

![Version: 0.1.0](https://img.shields.io/badge/Version-0.1.0-informational?style=flat-square)

## design goals / use cases

Custom configuration of ingresses depends on specific ingress controller/provider but in general it is achieved using
annotations.

Typically, Kong allows you to configure
- ingress as a whole (annotations on ingress)
- or even a single rule path (annotations on associated service object)

## services

This chart is designed to support usage with Kong on-ingress/on-service annotation model.

```yaml
services:
  http:
    selector:
      app: myapp
    port: 80 # optional, defaults to targetPort
    targetPort: 8080 # port name or number as defined by selected pod
    annotations: {} # optional
```

See rules for specific use cases.

## rules

Rules section maps specific hostnames and path prefixes to a given service.
Service is the logical name of the managed service from `services{}` section,
or an external/provided service/port reference.

```yaml
services:
  default:
    targetPort: 8080
rules:
  example.com:
    /: default
```

You can refer to 3rd party services using service/name-or-port syntax:

```yaml
rules:
  example.com:
    /: other-service/port-name # or other-service/8080 to refer to port number
```

You can specify annotations on ingress/service:

```yaml
annotations: {} # ingress scope, all rules
services:
  http1:
    annotations: {} # service scope
    targetPort: 8081
  http2:
    annotations: {} # service scope
    targetPort: 8082
rules:
  example.com:
    annotations: {} # ingress scope, this rule/host/ingress
    /prefix1: http1
    /prefix2: http2
```

## tls

Disabled by default. Enable using:
```yaml
tls:
  enabled: true
```

Specify secret containing TLS certificate:
```yaml
tls:
  secret: my-tls
```

Use cert-manager's Issuer/ClusterIssuer to generate/issue TLS certificate
```yaml
tls:
  issuer: cluster-issuer/letsencrypt # kind/name
  secret: ~ # no need to specify secret name, it is autogenerated
```

## Examples

### simple ingress

```yaml
services:
  default:
    targetPort: 8080
rules:
  example.com:
    /: default
```

### multiple services, shared port

If all your services use same port/targetPort, specify ports in $defaults

You can still override both port/targetPort on service level.

```yaml
defaults:
  #port: 8080 #optional
  targetPort: 8080
services:
  svc1: {}
  svc2: {}
  svc3: {}
rules: {...}
```

### templated values

use can use templated values in
- rules:hostname
- rules:hostname:path

```yaml
rules:
  # a) templated path
  example.com:
    '/{{.Release.Name}}': default
  # b) templated hostname
  '{{.Release.Name}}.example.com':
    /: default
```

### complex example

```yaml
class: kong
annotations:
  konghq.com/protocols: "https"
  konghq.com/https-redirect-status-code: "302"
  konghq.com/strip-path: "true"
defaults:
  targetPort: 8080
services:
  default:
    annotations:
      kong.hq/plugins: basic-auth
  anonymous:
    annotations: {}
rules:
  '{{.Release.Name}}.example.com':
    /: default
    /login: anonymous
    /logout: anonymous
tls:
  enabled: true
  issuer: cluster-issuer/letsencrypt
  hosts: [ '*.example.com' ]
```

## limitations / rejected design choices

This chart produces
- multiple ingresses (per `rules.*`)
- multiple services (per `services.*`)
- only one port per service, hence service per port

This may seem verbose but it allows distinct annotations{} per
ingress/service. Service annotations are typically application-scoped,
and bound to a specific port, hence it makes sense to decouple ports,
and this results in service per port model.

Enabling chart to generate optimized manifests with ad-hoc grouping
of ingress rules and service ports would result in increased
complexity of both chart configuration and chart implementation.

User is free to not use managed `services{}` and utilize external
`service/port` references in ingress rules.

User is also free not to use managed ingresses, and utilize only services
feature, and generate own ingress manifest(s) that use managed or external
services at will.

Also, user is free not to use this helm chart at all, if it does not fit
the use case, or if they do not like the output.

---

## Requirements

| Repository | Name | Version |
|------------|------|---------|
| file://../utils | utils | * |

## Values

| Key | Type | Default | Description |
|-----|------|---------|-------------|
| annotations | object | `{}` | ingress annotations |
| class | string | `"kong"` | ingress class |
| defaultBackend | object | `{}` | default backend configuration [doc](https://kubernetes.io/docs/concepts/services-networking/ingress/#default-backend) |
| defaults.port | string | `nil` | optional, defaults to $targetPort used if service does not specify $port or $targetPort |
| defaults.targetPort | string | `nil` | mandatory, no default used if service does not specify $targetPort |
| options.enableTemplatedAnnotations | bool | `false` | enables templating in annotations |
| rules | object | `{}` | ingress rules |
| rules.$hostname | object | `{"$service":"/path"}` | host name |
| services | object | `{}` | map of services |
| services.$name | object | `{}` | service alias |
| services.$name.annotations | object | `{}` | service annotations |
| services.$name.port | string | `.targetPort` | port number |
| services.$name.selector | object | `{}` | pod selector |
| services.$name.targetPort | string | `nil` | target port |
| tls | object | `{"enabled":false,"hosts":[],"issuer":null,"secret":null}` | ingress TLS configuration |
| tls.enabled | bool | `false` | enables TLS for ingress |
| tls.hosts | list | `rules.$hostname` | list of hosts for TLS |
| tls.issuer | string | `nil` | cert-manager issuer reference, syntax: `cluster-issuer/$name`, or `issuer/$name` |
| tls.secret | string | name of the ingress | TLS secret reference |

----------------------------------------------
Autogenerated from chart metadata using [helm-docs v1.12.0](https://github.com/norwoodj/helm-docs/releases/v1.12.0)
